"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function deepMerge(a, b) {
    const typeA = typeof a;
    const typeB = typeof b;
    if (typeA === typeB && typeA === "object" && typeA !== null && a !== b) {
        const isArrayA = Array.isArray(a);
        const isArrayB = Array.isArray(b);
        if (isArrayA && isArrayB) {
            return a.concat(b);
        }
        else if ((isArrayA && !isArrayB) || (!isArrayA && isArrayB)) {
            return b;
        }
        else {
            const output = Object.assign({}, a);
            for (const key in output) {
                if (b.hasOwnProperty(key)) {
                    output[key] = deepMerge(a[key], b[key]);
                }
            }
            for (const key in b) {
                if (!a.hasOwnProperty(key)) {
                    output[key] = b[key];
                }
            }
            return output;
        }
    }
    return b;
}
exports.deepMerge = deepMerge;
//# sourceMappingURL=deepMerge.js.map